package main

import (
	"fmt"
	"io/ioutil"
	"net/http"
	"net/url"
	"strings"
	"time"
)

var testApi = "http://myip.top"

func main() {
	getMyIp()

	//ip端口
	var proxyIP = "150.109.179.96:13613"
	go httpProxy(proxyIP, "", "")
	//账密
	go httpProxy("proxy.ipidea.io:2333", "账户-zone-custom-region-kr", "密码")

	time.Sleep(time.Minute)
}

func getMyIp() {
	rsp, err := http.Get("http://myip.top")
	if err != nil {
		fmt.Println("获取本机ip失败", err.Error())
		return
	}
	defer rsp.Body.Close()
	body, err := ioutil.ReadAll(rsp.Body)
	if err != nil {
		fmt.Println(err.Error())
		return
	}
	fmt.Println(time.Now().Format("2006-01-02 15:04:05 07"), "本机ip:", string(body))

}

func httpProxy(proxyUrl, user, pass string) {
	defer func() {
		if err := recover(); err != nil {
			fmt.Println(time.Now().Format("2006-01-02 15:04:05 07"), "http", "返回信息:", err)
		}
	}()
	urli := url.URL{}

	if !strings.Contains(proxyUrl, "http") {
		proxyUrl = fmt.Sprintf("http://%s", proxyUrl)
	}

	urlProxy, _ := urli.Parse(proxyUrl)
	if user != "" && pass != "" {
		urlProxy.User = url.UserPassword(user, pass)
	}

	client := &http.Client{
		Transport: &http.Transport{
			Proxy: http.ProxyURL(urlProxy),
		},
	}
	rqt, err := http.NewRequest("GET", testApi, nil)
	if err != nil {
		panic(err)
		return
	}
	response, err := client.Do(rqt)
	if err != nil {
		panic(err)
		return
	}

	defer response.Body.Close()
	if false {
		body, _ := ioutil.ReadAll(response.Body)
		fmt.Println(time.Now().Format("2006-01-02 15:04:05 07"), "【http success】", "返回信息:", string(body))
	} else {
		body, _ := ioutil.ReadAll(response.Body)
		fmt.Println(time.Now().Format("2006-01-02 15:04:05 07"), "【http success】", "返回信息:", response.Status, string(body))
	}

	return
}
